﻿/** @file TarUtility.cs
 *  
 * Tar/Untar Function
 * 
 * Copyright (c) 2013 SHARP CORPORATION
 * 
 * @change 2013/8/1 new
 */

using System.IO;
using ICSharpCode.SharpZipLib.Zip.Compression.Streams;
using ICSharpCode.SharpZipLib.Tar;

namespace EnoteUtility
{
    class TarUtility
    {
      	public static void Untar(string tarFile, string extractPath)
		{
            Stream inStream = File.OpenRead(tarFile);
            Stream st = new InflaterInputStream(inStream);
            TarArchive archive = TarArchive.CreateInputTarArchive(inStream, TarBuffer.DefaultBlockFactor);

            archive.SetKeepOldFiles(false);
            archive.AsciiTranslate = false;
            archive.SetUserInfo(0, "", 0, "None");

            Directory.CreateDirectory(extractPath);

            archive.ExtractContents(extractPath);

            archive.Close();

            inStream.Close();
        }

        public static void Tar(string tarFile, string[] files)
        {
            Stream outStream = File.Create(tarFile);
            Stream st = new DeflaterOutputStream(outStream);
            TarArchive archive = TarArchive.CreateOutputTarArchive(outStream, TarBuffer.DefaultBlockFactor);

            archive.SetKeepOldFiles(false);
            archive.AsciiTranslate = false;
            archive.SetUserInfo(0, "", 0, "None");

            foreach(string file in files)
            {
                TarEntry entry = TarEntry.CreateEntryFromFile(file);
                archive.WriteEntry(entry, true);
            }

            archive.Close();

            outStream.Close();
        }
    }
}
